/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
  
 decodersapass.c v 1.8.0  2000/04/14    - Use RSA encryption protocol
                 v 1.8.7  2000/05/29    - Correct bug
                 v 1.8.10 2000/08/11    - Portage to Linux
                 v 1.9.0  2000/08/18    - Use configure to help portage
                 v 2.0.1  2001/04/23    - Correct indentation

*****************************************************************************/

#include <netinet/in.h>
#include <stdlib.h>
#include <sys/time.h>

#include <bbftpd.h>
#include <structures.h>
#include <openssl/rsa.h>
#include <openssl/err.h>

extern RSA    *myrsa ;

int decodersapass(char *buffer, char *username, char *password) 
{
    struct mess_rsa *msg_rsa ;
    int    lenuser ;
    int lenpass ;
    
    msg_rsa = (struct mess_rsa *) buffer ;

#ifndef WORDS_BIGENDIAN
    msg_rsa->numuser = ntohl(msg_rsa->numuser) ;
    msg_rsa->numpass = ntohl(msg_rsa->numpass) ;
#endif
    lenuser = RSA_private_decrypt(msg_rsa->numuser,msg_rsa->cryptuser,(unsigned char *)username,myrsa,RSA_PKCS1_OAEP_PADDING) ;
    username[lenuser] = '\0' ;
    lenpass = RSA_private_decrypt(msg_rsa->numpass,msg_rsa->cryptpass,(unsigned char *)password,myrsa,RSA_PKCS1_OAEP_PADDING) ;
    password[lenpass] = '\0' ;
    
    return 0 ;
}
