/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.

 Routines : void strip_trailing_slashes (char *path)
            void free_all_var() 
 
 utils_v2.c v 2.0.0 2000/12/19  - Routine creation
            v 2.0.1 2001/04/23  - Correct indentation
*****************************************************************************/
#include <stdio.h>

extern char *curfilename ;
extern char *realfilename ;
extern int  curfilenamelen ;
extern int  *myports ;
extern int  *mychildren ;
extern int  *readbuffer;
extern int  *compbuffer;
extern int  nbpidchild ;



/*
** Taken from Free Software Foundation
*/
void strip_trailing_slashes (char *path)
{
  int last;

  last = strlen (path) - 1;
  while (last > 0 && path[last] == '/')
    path[last--] = '\0';
}

/*******************************************************************************
** free_all_var :                                                              *
**                                                                             *
**      Routine to free all global variables                                   *
**                                                                             *
**                                                                             *
**      GLOBAL VARIABLE USED :                                                 *                                                                      *
**                 all                                                         *
**                                                                             *
**                                                                             *
*******************************************************************************/

void free_all_var() 
{
    if ( curfilename != NULL ) {
        free(curfilename) ;
        curfilename = NULL ;
        curfilenamelen = 0 ;
    }
    if ( realfilename != NULL ) {
        free(realfilename) ;
        realfilename = NULL ;
    }
    if ( myports != NULL ) {
        free(myports) ;
        myports = NULL ;
    }
    if ( mychildren != NULL ) {
        free(mychildren) ;
        mychildren = NULL ;
    }
    if ( readbuffer != NULL ) {
        free(readbuffer) ;
        readbuffer = NULL ;
    }
    if ( compbuffer != NULL ) {
        free(compbuffer) ;
        compbuffer = NULL ;
    }
    nbpidchild = 0 ;
}
        
