/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
  
 writemessage.c v 1.6.0  2000/03/25 - Creation of the routine
                v 1.6.1  2000/03/24 - Portage to OSF1
                                    - Set the socket in non block mode
                v 1.8.10 2000/08/11 - Portage to Linux
                v 1.9.0  2000/08/24 - Use configure to help port
                v 1.9.4  2000/10/16 - Supress %m
                v 2.0.0  2000/12/18 - Change send for write for ssh mode
                                      (Tin Adye)
                v 2.0.1  2001/04/23 - Correct indentation
 
*****************************************************************************/
#include <errno.h>
#include <stdio.h>
#include <syslog.h>
#include <sys/time.h>
#include <unistd.h>

#include <daemon.h>


int writemessage(int sock,char *buffer,int msglen,int to) 
{
    int    nbsent ;
    int    retcode ;
    int        nfds ;
    fd_set    selectmask ; /* Select mask */
    struct timeval    wait_timer;

    nbsent = 0 ;
/*
** start the writing loop
*/
    while ( nbsent < msglen ) {
        nfds = sysconf(_SC_OPEN_MAX) ;
        FD_ZERO(&selectmask) ;
        FD_SET(sock,&selectmask) ;
        wait_timer.tv_sec  = to ;
        wait_timer.tv_usec = 0 ;
        if ( (retcode = select(nfds,0,&selectmask,0,&wait_timer) ) == -1 ) {
            /*
            ** Select error
            */
            syslog(LOG_ERR,"Write message : Select error : MSG (%d,%d)",msglen,nbsent) ;
            return -1 ;
        } else if ( retcode == 0 ) {
            syslog(LOG_ERR,"Write message : Time out : MSG (%d,%d)",msglen,nbsent) ;
            return -1 ;
        } else {
            retcode = write(sock,&buffer[nbsent],msglen-nbsent) ;
            if ( retcode < 0 ) {
                syslog(LOG_ERR,"Write message : write error : MSG (%d,%d) : %s",msglen,nbsent,strerror(errno)) ;
                return -1 ;
            } else if ( retcode == 0 ) {
                syslog(LOG_ERR,"Write message : Connexion breaks") ;
                return -1 ;
            } else {
                nbsent = nbsent + retcode ;
            }
        }
    }
    return(0) ;
}
