/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
 
*****************************************************************************/
#include <errno.h>
#include <fcntl.h>
#include <netdb.h>
#include <netinet/in.h>
#include <pwd.h>
#include <signal.h>
#include <stdio.h>
#include <syslog.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/un.h>
#include <unistd.h>

main()
{
	struct	sockaddr_un unixsocaddr ;
	int		unixsocaddrlen ;
	int		newstdin,newstdout,newstderr ;
	int		tmpsock ;
	int		nfds ;
	fd_set	selectmask ; /* Select mask */
	int		j, retcode, i ;
	struct timeval	wait_timer;
	
	if ( (newstdin = socket(AF_UNIX,SOCK_STREAM,0) ) < 0 ) {
		printf("Cannot create newstdin socket : %s\n",strerror(errno)) ;
		exit(1) ;
	}
	unixsocaddr.sun_family = AF_UNIX ;
	sprintf(unixsocaddr.sun_path,"/tmp/xxxxx") ;
	unixsocaddrlen = sizeof(unixsocaddr) ;
	if ( bind(newstdin,(struct sockaddr *)&unixsocaddr,unixsocaddrlen) < 0 ) {
		/*
		** That means that the file still exist which is completly
		** abnormal so destroy the file and retry
		*/
		unlink( unixsocaddr.sun_path) ;
		if ( bind(newstdin,(struct sockaddr *)&unixsocaddr,unixsocaddrlen) < 0 ) {
			/*
			** Again ... so exit 
			*/
			printf("Error binding stdin socket : %s\n",strerror(errno)) ;
			exit(1) ;
		}
	}
	if ( listen(newstdin,1) < 0 ) {
		printf("Error listening stdin socket : %s\n",strerror(errno)) ;
		exit(1) ;
	}
	nfds = sysconf(_SC_OPEN_MAX) ;
	FD_ZERO(&selectmask) ;
	FD_SET(newstdin,&selectmask) ;
	wait_timer.tv_sec  = 1000 ;
	wait_timer.tv_usec = 0 ;
	if ( (retcode = select(nfds,&selectmask,0,0,&wait_timer) ) == -1 ) {
		printf("Select error waiting connection stdin %s\n",strerror(errno)) ;
		exit(1) ;
	} else if ( retcode == 0 ) {
		/*
		** Time out, unlink all files and exit
		*/
		printf("Time out waiting connection stdin\n") ;
		exit(1) ;
	} else {
		if ( (tmpsock = accept(newstdin,0,0) ) < 0 ) {
			printf("Accept failed on stdin %s\n",strerror(errno)) ;
			exit(1) ;
		}
		close(newstdin) ;
		newstdin = tmpsock ;
	}
	
}
